Index: src/core/include/tsp_const_def.h
===================================================================
--- src/core/include/tsp_const_def.h	(révision 4)
+++ src/core/include/tsp_const_def.h	(révision 205)
@@ -45,7 +45,7 @@
 #define TSP_PROTOCOL_VERSION 0x00010001
 
 /* we need abstract types for multi-platform portability */
-#include <tsp_abs_types.h>
+#include "tsp_abs_types.h"
 
 #define TSP_MAX_SYSMSG_SIZE 256
 
@@ -88,10 +88,12 @@
 
 /** used to calculate the socket buffer size */
 #define TSP_DATA_STREAM_MAX_HEADER_SIZE 1024
+/** No more than 2MB buffer size which is already HUGE */
+#define TSP_DATA_STREAM_MAX_BUFFER_MAXSIZE (1024*1024*2)
 /* till now, all elements are doubles, but there will be strings, raw, etc ... */
-#define TSP_DATA_STREAM_MAX_ITEM_SIZE sizeof(double)*8096
+#define TSP_DATA_STREAM_MAX_ITEM_SIZE sizeof(double)*10
 #define TSP_DATA_STREAM_MAX_BUFFER_SIZE(max_nb_items) \
-             ( (max_nb_items) * TSP_DATA_STREAM_MAX_ITEM_SIZE \
+  ( ((max_nb_items) * TSP_DATA_STREAM_MAX_ITEM_SIZE) > TSP_DATA_STREAM_MAX_BUFFER_MAXSIZE ? TSP_DATA_STREAM_MAX_BUFFER_MAXSIZE :  (max_nb_items) * TSP_DATA_STREAM_MAX_ITEM_SIZE \
                               + TSP_DATA_STREAM_MAX_HEADER_SIZE)
 
 
Index: src/core/include/tsp_glu.h
===================================================================
--- src/core/include/tsp_glu.h	(révision 4)
+++ src/core/include/tsp_glu.h	(révision 205)
@@ -40,7 +40,9 @@
 
 #include <tsp_prjcfg.h>
 #include <tsp_datastruct.h>  /* FIXME : just for TSP_sample_symbol_info_list_t, and shouldn't use generated rpc struct */
-
+#if defined (WIN32)
+#include <pthread.h>
+#endif
 /* forward declare datapool type */
 struct TSP_datapool;
 
@@ -148,23 +150,23 @@
  * This string will be used by the consumers to get informations
  * about a provider. It must be meaningfull (ex : "Temperatures Sampler" ) 
  */
-typedef char*              (* GLU_get_server_name_ft   )(struct GLU_handle_t* this);
+typedef char*              (* GLU_get_server_name_ft   )(struct GLU_handle_t* cthis);
 /**
  * GLU server type getter.
  * Will get the GLU type i.e. ACTIVE or PASSIVE.
  * @return GLU server type.
  */
-typedef GLU_server_type_t  (* GLU_get_server_type_ft   )(struct GLU_handle_t* this);
+typedef GLU_server_type_t  (* GLU_get_server_type_ft   )(struct GLU_handle_t* cthis);
 /**
  * Default GLU base frequency.
  * @return GLU base frequency (Hz)
  */
-typedef double             (* GLU_get_base_frequency_ft)(struct GLU_handle_t* this);
+typedef double             (* GLU_get_base_frequency_ft)(struct GLU_handle_t* cthis);
 /**
  * The maximum number of consumer connection
  * @return maximum number of consumer connection
  */
-typedef int32_t             (* GLU_get_nb_max_consumer_ft)(struct GLU_handle_t* this);
+typedef int32_t             (* GLU_get_nb_max_consumer_ft)(struct GLU_handle_t* cthis);
 /**
  * GLU instance creation.
  * This function will be called by the provider for each consumer
@@ -194,7 +196,7 @@
  * to get detailed information about the error. 
  * @return The created GLU handle. Returns 0 when the function fail
  */
-typedef struct GLU_handle_t*      (* GLU_get_instance_ft      )(struct GLU_handle_t* this, int32_t custom_argc, char* custom_argv[], char** error_info);
+typedef struct GLU_handle_t*      (* GLU_get_instance_ft      )(struct GLU_handle_t* cthis, int32_t custom_argc, char* custom_argv[], char** error_info);
 /**
  * GLU initialization function.
  *
@@ -243,20 +245,20 @@
  * @return Return FALSE if a fatal error occur during initialisation
  * or if there is a probleme with the provided parameters
  */
-typedef int32_t                (* GLU_init_ft              )(struct GLU_handle_t* this,int32_t fallback_argc, char* fallback_argv[]);
+typedef int32_t                (* GLU_init_ft              )(struct GLU_handle_t* cthis,int32_t fallback_argc, char* fallback_argv[]);
 /**
  * Start the loop that will push data to datapool with push_next_item
  * 
  * @return status 
  */
-typedef void*              (* GLU_run_ft               )(void* this);
+typedef void*              (* GLU_run_ft               )(void* cthis);
 /**
  * Start push datapool GLU activity AS A SEPARATE thread.
  * The start function should NOT block, the defaut implementation
  * is to start a new thread running the 'GLU_run_ft' of the GLU. 
  * @return 0 on success and other value on error.
  */
-typedef int32_t                (* GLU_start_ft             )(struct GLU_handle_t* this);
+typedef int32_t                (* GLU_start_ft             )(struct GLU_handle_t* cthis);
 /** 
  * GLU_get_provider_global_indexes provider global indexes corresponding
  * to given symbol list. Used to validate client provided symbol list
@@ -264,51 +266,51 @@
  * @param[out] pg_indexes array containing corresponding provider global indexes or -1 if not found 
  * @return TRUE if all symbol found, else return FALSE 
  */
-typedef int32_t                (* GLU_get_pgi_ft           )(struct GLU_handle_t* this, TSP_sample_symbol_info_list_t* symbol_list, int* pg_indexes);
+typedef int32_t                (* GLU_get_pgi_ft           )(struct GLU_handle_t* cthis, TSP_sample_symbol_info_list_t* symbol_list, int* pg_indexes);
 /**
  * List of symbols managed by the GLU.
  * @param this Handle for the GLU (when the GLU is ACTIVE, it is always equal to GLU_GLOBAL_HANDLE)
  * @param symbol_list List of symbols
  * @return TRUE of FALSE. TRUE = OK;
  */
-typedef int32_t                (* GLU_get_ssi_list_ft  )(struct GLU_handle_t* this, TSP_sample_symbol_info_list_t* symbol_list);
+typedef int32_t                (* GLU_get_ssi_list_ft  )(struct GLU_handle_t* cthis, TSP_sample_symbol_info_list_t* symbol_list);
 
 /**
  * Filtered list of symbols managed by the GLU.
- * @param[in] this Handle for the GLU (when the GLU is ACTIVE, it is always equal to GLU_GLOBAL_HANDLE)
+ * @param[in] cthis Handle for the GLU (when the GLU is ACTIVE, it is always equal to GLU_GLOBAL_HANDLE)
  * @param[in] filter_kind the filter kind
  * @param[in] filter_string the filter string
  * @param[out] ans_sample the answer_sample to be filled-in by the GLU.
  * @return TRUE of FALSE. TRUE = OK;
  */
-typedef int32_t                (* GLU_get_filtered_ssi_list_ft)(struct GLU_handle_t* this, int32_t filter_kind, char* filter_string, TSP_answer_sample_t* symbol_list);
+typedef int32_t                (* GLU_get_filtered_ssi_list_ft)(struct GLU_handle_t* cthis, int32_t filter_kind, char* filter_string, TSP_answer_sample_t* symbol_list);
 
 /**
  * Get Sample Symbols Info list from PGI lists.
- * @param[in] this Handle for the GLU (when the GLU is ACTIVE, it is always equal to GLU_GLOBAL_HANDLE)
+ * @param[in] cthis Handle for the GLU (when the GLU is ACTIVE, it is always equal to GLU_GLOBAL_HANDLE)
  * @param[in] pgis the array of requested PGI
  * @param[in] pgis_len the length of the pgis array
  * @param[in,out] the preallocated SSI list. 
  * @return TRUE of FALSE. TRUE = OK;
  */
-typedef int32_t                (* GLU_get_ssi_list_fromPGI_ft)(struct GLU_handle_t* this, int* pgis, int32_t pgis_len, TSP_sample_symbol_info_list_t* SSI_list);
+typedef int32_t                (* GLU_get_ssi_list_fromPGI_ft)(struct GLU_handle_t* cthis, int* pgis, int32_t pgis_len, TSP_sample_symbol_info_list_t* SSI_list);
 
 /**
  * Get Sample Symbols Extended Info list from PGI lists.
- * @param[in] this Handle for the GLU (when the GLU is ACTIVE, it is always equal to GLU_GLOBAL_HANDLE)
+ * @param[in] cthis Handle for the GLU (when the GLU is ACTIVE, it is always equal to GLU_GLOBAL_HANDLE)
  * @param[in] pgis the array of requested PGI
  * @param[in] pgis_len the length of the pgis array
  * @param[in,out] on entry the preallocated SSEI list, on return the updated SSEI list
  * @return TRUE of FALSE. TRUE = OK;
  */
-typedef int32_t                (* GLU_get_ssei_list_fromPGI_ft)(struct GLU_handle_t* this, int* pgis, int32_t pgis_len, TSP_sample_symbol_extended_info_list_t* SSEI_list);
+typedef int32_t                (* GLU_get_ssei_list_fromPGI_ft)(struct GLU_handle_t* cthis, int* pgis, int32_t pgis_len, TSP_sample_symbol_extended_info_list_t* SSEI_list);
 
 /**
  * Get the number of symbols managed by the GLU.
  * @param this Handle for the GLU (when the GLU is ACTIVE, it is always equal to GLU_GLOBAL_HANDLE)
  * @return the number of symbols;
  */
-typedef int32_t                (* GLU_get_nb_symbols_ft  )(struct GLU_handle_t* this);
+typedef int32_t                (* GLU_get_nb_symbols_ft  )(struct GLU_handle_t* cthis);
 
 /**
  * GLU asynchronous sample write.
@@ -322,7 +324,7 @@
  * @param[in] value_size the size of the value.
  * @return >0 on success <=0 on failure
  */
-typedef int32_t                (* GLU_async_sample_write_ft)(struct GLU_handle_t* this, int32_t pgi, void* value_ptr, uint32_t value_size);
+typedef int32_t                (* GLU_async_sample_write_ft)(struct GLU_handle_t* cthis, int32_t pgi, void* value_ptr, uint32_t value_size);
 
 /**
  * GLU asynchronous sample read.
@@ -336,7 +338,7 @@
  * @param[in,out] value_size the size of the value.
  * @return >0 on success <=0 on failure
  */
-typedef int32_t                (* GLU_async_sample_read_ft)(struct GLU_handle_t* this, int32_t pgi, void* value_ptr, uint32_t* value_size);
+typedef int32_t                (* GLU_async_sample_read_ft)(struct GLU_handle_t* cthis, int32_t pgi, void* value_ptr, uint32_t* value_size);
 
                 
 /** 
@@ -445,7 +447,7 @@
  * @param[in] base_frequency the base frequency that will be advertised by the TSP provider
  * @return TRUE if ok FALSE otherwise
  */
-int32_t GLU_handle_create(GLU_handle_t** glu, const char* name, const GLU_server_type_t type, const double base_frequency);
+_EXPORT_TSP_PROVIDER int32_t GLU_handle_create(GLU_handle_t** glu, const char* name, const GLU_server_type_t type, const double base_frequency);
 
 /**
  * Destroy a GLU_handle.
Index: src/core/include/tsp_simple_trace.h
===================================================================
--- src/core/include/tsp_simple_trace.h	(révision 4)
+++ src/core/include/tsp_simple_trace.h	(révision 205)
@@ -55,7 +55,7 @@
            printf text; printf("\n"); fflush(stdout);\
     }\
 } 
-#ifdef __GNUC__       
+#if defined(__GNUC__) || defined(_MSC_VER)
 #  define SIMPLE_TRACE(level,src,text) SIMPLE_TRACE_FUNC(level,src,__FUNCTION__,text)
 #else 
 #  define SIMPLE_TRACE(level,src,text) SIMPLE_TRACE_FUNC(level,src,"where?",text)
Index: src/core/include/tsp_abs_types.h
===================================================================
--- src/core/include/tsp_abs_types.h	(révision 4)
+++ src/core/include/tsp_abs_types.h	(révision 205)
@@ -45,8 +45,8 @@
 #undef BEGIN_C_DECLS
 #undef END_C_DECLS
 #ifdef __cplusplus
-# define BEGIN_C_DECLS extern "C" {
-# define END_C_DECLS }
+#  define BEGIN_C_DECLS extern "C" {
+#  define END_C_DECLS }
 #else
 # define BEGIN_C_DECLS /* empty */
 # define END_C_DECLS /* empty */
@@ -63,6 +63,7 @@
 /*** Platform specific ***/
 
 /* SUN / sparc|i386 (32/64 bits) */
+/* AP : Migration sous Windows */
 #if  defined(__sun)
 # define TSP_BYTE_ORDER TSP_BIG_ENDIAN
 # define TSP_SYSTEM_HAVE_GETHRTIME
@@ -93,17 +94,68 @@
 #		define _INT32_T
 #	endif
 #	ifndef _UINT64_T
-		typedef u_longlong_t    uint64_t;
+	    typedef u_longlong_t        uint64_t;
 #		define _UINT64_T
 #	endif
 #	ifndef _INT64_T
-		typedef longlong_t    int64_t;
+	    typedef longlong_t    int64_t;
 #		define _INT64_T
 #	endif
 #   endif /* Exists SYS_TYPES_H */ 
 # endif /* ! sparcv9 */
 #endif /* SUN */
 
+/* Windows */
+#if defined (WIN32)
+#include <stddef.h>
+/* with UWin */
+#if defined (_UWIN)
+
+#include <stdint.h>
+
+#else /* FIXME */
+
+/* types for compat. with various BSD and other library sources */
+typedef signed char      int8_t;
+typedef unsigned char  u_int8_t;
+typedef short            int16_t;
+typedef unsigned short u_int16_t;
+typedef int              int32_t;
+typedef unsigned int   u_int32_t;
+/* types for compat. with Solaris 7 */
+typedef unsigned char  uint8_t;
+typedef unsigned short uint16_t;
+typedef unsigned int   uint32_t;
+/*
+ * 64bit type for BSD compatability
+ */
+#ifdef __GNUC__
+typedef long long int 		  quad_t;
+typedef unsigned long long int	u_quad_t;
+typedef long long int             int64_t;
+typedef unsigned long long int  u_int64_t;
+#elif _MSC_VER
+typedef __int64 		  quad_t;
+typedef unsigned __int64 	u_quad_t;
+typedef __int64 		  int64_t;
+typedef unsigned __int64 	u_int64_t;
+#endif /*__GNUC__*/
+
+#ifndef _UINT64_T
+    typedef unsigned long long  uint64_t;
+#   define _UINT64_T
+#endif
+#ifndef _INT64_T
+    typedef long long  int64_t;
+#	define _INT64_T
+#endif
+
+#endif /* with UWin */
+# define TSP_BYTE_ORDER TSP_LITTLE_ENDIAN
+# define TSP_INT64_CONSTANT(val)  (val##LL)
+# define TSP_HAVE_INT64 1
+#endif /* Windows with UWin */
+
 
 /* Linux / Intel */
 #if defined (__linux__) &&  ( defined (__i386__)  || defined (__x86_64__) )
@@ -116,7 +168,6 @@
 #endif /* Linux / Intel */
 
 
-
 /* Linux / Powerpc */ 							
 #if defined (__linux__) &&  defined (__powerpc__)  
 # include <stdint.h>							
Index: src/core/include/tsp_sys_headers.h
===================================================================
--- src/core/include/tsp_sys_headers.h	(révision 4)
+++ src/core/include/tsp_sys_headers.h	(révision 205)
@@ -52,14 +52,19 @@
 #define _POSIX_C_SOURCE 199506L
 #endif
 
+#ifndef WIN32
 #include <unistd.h>
-#include <assert.h>
+#endif
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
+#ifndef WIN32
 #include <strings.h>
+#endif
 #include <errno.h>
+#ifndef WIN32 /* conflict error C2011 under VC++, already include by <rpc/rpc.h> */
 #include <netdb.h>
+#endif
 /*#include "fortify.h"*/
 
 
@@ -77,8 +82,10 @@
 #endif /* OSF1 / Alpha */
 
 #include <pthread.h>
+#ifndef WIN32
 #include <sys/time.h>
 #include <sys/param.h>
+#endif
 
 #ifdef VXWORKS
 /* VXWORKS part */
Index: src/core/include/tsp_prjcfg.h.in
===================================================================
--- src/core/include/tsp_prjcfg.h.in	(révision 4)
+++ src/core/include/tsp_prjcfg.h.in	(révision 205)
@@ -51,6 +51,38 @@
 
 #include <tsp_simple_trace.h>
 
+/*
+ * The following macro is used under windows system to declare 
+ * the DLLs tsp_provider, tsp_common entries points
+ */
+#undef _EXPORT_TSP_PROVIDER
+#undef _EXPORT_TSP_COMMON
+#if defined (WIN32) && defined (TSP_SHARED_LIBS)
+#  ifdef tsp_provider_EXPORTS
+#    define _EXPORT_TSP_PROVIDER __declspec(dllexport)
+#  else
+#    define _EXPORT_TSP_PROVIDER __declspec(dllimport)
+#  endif
+#  ifdef tsp_common_EXPORTS
+#    define _EXPORT_TSP_COMMON __declspec(dllexport) 
+#  else
+#    define _EXPORT_TSP_COMMON __declspec(dllimport) 
+#  endif
+#else
+#  define _EXPORT_TSP_PROVIDER
+#  define _EXPORT_TSP_COMMON
+#endif
+
+/*
+ * The following macro is used under windows system to declare 
+ * the DLLs tsp_provider, tsp_common constant variables
+ */
+#if defined (_EXPORT_TSP_COMMON) && defined(WIN32)
+#  define _EXTERN_TSP_COMMON extern _EXPORT_TSP_COMMON
+#else
+#  define _EXTERN_TSP_COMMON extern
+#endif
+
 /* 
  * The TSP doxygen modules are now defined
  * in tsp/src/doxy/tsp_doc_tree.dox
Index: src/core/ctrl/tsp_datapool.h
===================================================================
--- src/core/ctrl/tsp_datapool.h	(révision 4)
+++ src/core/ctrl/tsp_datapool.h	(révision 205)
@@ -91,27 +91,27 @@
 
 /**
  * Get the reverse list of global_index wanted by some consumers
- * @param[in] this the datapool object
+ * @param[in] cthis the datapool object
  * @param[in]  nb   pointer on where to store the number of items
  * @param[out] list pointer on list of global_index
  */ 
-void TSP_datapool_get_reverse_list (TSP_datapool_t* this, int *nb, int **list);
+_EXPORT_TSP_PROVIDER void TSP_datapool_get_reverse_list (TSP_datapool_t* cthis, int *nb, int **list);
 
 /**
  * Push GLU data into datapool.
- * @param[in,out] this  the datapool object
+ * @param[in,out] cthis  the datapool object
  * @param[in]     item  the GLU item to push in the datapool. The item is copied
  *                      and may be re-used on return.
  */ 
-int TSP_datapool_push_next_item(TSP_datapool_t* this, glu_item_t* item);
+_EXPORT_TSP_PROVIDER int TSP_datapool_push_next_item(TSP_datapool_t* cthis, glu_item_t* item);
 
 /**
  * End of push, we commit the whole
- * @param[in,out] this the datapool object to commit in.
+ * @param[in,out] cthis the datapool object to commit in.
  * @param[in] time_stamp  date of datapool items
  * @param[in] state ok or error (reconf,eof, ...)
  */ 
-int TSP_datapool_push_commit(TSP_datapool_t* this, time_stamp_t time_stamp, GLU_get_state_t state);
+_EXPORT_TSP_PROVIDER int TSP_datapool_push_commit(TSP_datapool_t* cthis, time_stamp_t time_stamp, GLU_get_state_t state);
 
 
 /**
@@ -137,20 +137,20 @@
  * Initialize datapool with provided GLU.
  * This function will allocate internal datapool structure.
  * After this datapool is ready to be used by the refered GLU.
- * @param[in,out] this the datapool to be initialized
+ * @param[in,out] cthis the datapool to be initialized
  * @param[in,out] glu the GLU to be linked with the datapool
  * @return TSP_STATUS_OK on success.
  */
 int32_t 
-TSP_datapool_initialize(TSP_datapool_t* this, GLU_handle_t* glu);
+TSP_datapool_initialize(TSP_datapool_t* cthis, GLU_handle_t* glu);
 
 /**
  * Initialize datapool with provided GLU.
- * @param[in,out] this the datapool to be finalized
+ * @param[in,out] cthis the datapool to be finalized
  * @return TSP_STATUS_OK on success.
  */
 int32_t 
-TSP_datapool_finalize(TSP_datapool_t* this);
+TSP_datapool_finalize(TSP_datapool_t* cthis);
 
 /**
  * Get the datapool instance for this GLU.
@@ -170,12 +170,12 @@
 
 /**
  * Get the address of a value in the datapool
- * @param this The datapool handle
+ * @param cthis The datapool handle
  * @param provider_global_index The index of the symbol that is searched
  * @return The data address
  */ 
 void* 
-TSP_datapool_get_symbol_value(TSP_datapool_t* this, 
+TSP_datapool_get_symbol_value(TSP_datapool_t* cthis, 
 			      int provider_global_index);
 
  
Index: src/core/ctrl/tsp_data_sender.c
===================================================================
--- src/core/ctrl/tsp_data_sender.c	(révision 4)
+++ src/core/ctrl/tsp_data_sender.c	(révision 205)
@@ -36,6 +36,12 @@
 -----------------------------------------------------------------------
  */
 
+#ifdef WIN32
+    #define assert(exp)     ((void)0)
+#else
+    #include <assert.h>
+#endif
+
 #include <tsp_sys_headers.h>
 #include <rpc/types.h>
 #include <rpc/xdr.h>
Index: src/core/ctrl/tsp_session.c
===================================================================
--- src/core/ctrl/tsp_session.c	(révision 4)
+++ src/core/ctrl/tsp_session.c	(révision 205)
@@ -41,6 +41,12 @@
 #include <machine/endian.h>
 #endif /* __OpenBSD__ */
 
+#ifdef WIN32
+    #define assert(exp)     ((void)0)
+#else
+    #include <assert.h>
+#endif
+
 #include <tsp_sys_headers.h>
 #include <tsp_time.h>
 #include <tsp_session.h>
@@ -187,7 +193,7 @@
 } /* end of TSP_session_destroy_symbols_table */
 
 void 
-TSP_session_init(void) {
+TSP_session_init() {
   if( FALSE == X_initialized )
     {
       /* Mise a 0 de la zone memoire */
@@ -197,8 +203,9 @@
 }
 
 GLU_handle_t* TSP_session_get_GLU_by_channel(channel_id_t channel_id) {
+  TSP_session_t* session = NULL;
   TSP_LOCK_MUTEX(&X_session_list_mutex,NULL);
-  TSP_session_t* session;
+  /* TSP_session_t* session; */
   TSP_GET_SESSION(session,channel_id,NULL);  
   TSP_UNLOCK_MUTEX(&X_session_list_mutex,NULL);
   return session->session_data->glu_h;
@@ -232,7 +239,7 @@
 
 
 int 
-TSP_session_get_nb_session(void) {
+TSP_session_get_nb_session() {
   int client_number;
 
   TSP_LOCK_MUTEX(&X_session_list_mutex,-1);
@@ -671,12 +678,11 @@
 						TSP_sample_symbol_info_list_t* symbol_list)
 {
     TSP_session_t* session;
-    int ret=TRUE;
-    TSP_LOCK_MUTEX(&X_session_list_mutex,FALSE);
-    TSP_GET_SESSION(session, channel_id, FALSE);
     GLU_handle_t* myGLU;
-    
+    int ret=TRUE;
     int* pg_indexes = calloc( symbol_list->TSP_sample_symbol_info_list_t_len, sizeof(int) );
+    TSP_LOCK_MUTEX(&X_session_list_mutex,FALSE);
+    TSP_GET_SESSION(session, channel_id, FALSE);    
     
     if (pg_indexes == NULL) {
       STRACE_ERROR(("Unable to allocate memory for global provider index"));
Index: src/core/ctrl/tsp_request_handler.c
===================================================================
--- src/core/ctrl/tsp_request_handler.c	(révision 4)
+++ src/core/ctrl/tsp_request_handler.c	(révision 205)
@@ -41,12 +41,12 @@
 #include "tsp_time.h"
 
 int 
-TSP_provider_rqh_manager_get_max_nb(void) {
+TSP_provider_rqh_manager_get_max_nb() {
   return TSP_MAX_REQUEST_HANDLERS;
 }
 
 int
-TSP_provider_rqh_manager_get_nb(void) {
+TSP_provider_rqh_manager_get_nb() {
 
   int retval = 0;
   int i;
@@ -63,7 +63,7 @@
 
 
 int 
-TSP_provider_rqh_manager_get_nb_running(void) {
+TSP_provider_rqh_manager_get_nb_running() {
 
   int retval = 0;
   STRACE_IO(("-->IN"));
@@ -137,7 +137,7 @@
 } /* End of TSP_provider_rqh_manager_install */
 
 int 
-TSP_provider_rqh_manager_init(void) {
+TSP_provider_rqh_manager_init() {
 
   int retval = TRUE;
   int i;
@@ -155,7 +155,12 @@
   rqh_manager_if.nb_running_rhq = 0;
   /* RAZ handlers array */ 
   for (i=0;i<TSP_provider_rqh_manager_get_max_nb();++i) {
+#if defined (WIN32)
+    /* structure pthread_t different under Windows */
+    rqh_manager_if.request_handlers[i].tid.p              = 0;
+#else
     rqh_manager_if.request_handlers[i].tid                = 0;
+#endif
     rqh_manager_if.request_handlers[i].status             = TSP_RQH_STATUS_NOTINSTALLED;
     rqh_manager_if.request_handlers[i].config_param       = NULL;
     rqh_manager_if.request_handlers[i].config             = NULL;
@@ -170,7 +175,7 @@
 
 
 int 
-TSP_provider_rqh_manager_refresh(void) {
+TSP_provider_rqh_manager_refresh() {
 
   int retval = TRUE, timeout;
   TSP_provider_request_handler_t *rqh_p;
@@ -227,7 +232,7 @@
 
 
 
-int TSP_provider_rqh_manager_end(void)
+int TSP_provider_rqh_manager_end()
 {
   int timeout;
   TSP_provider_request_handler_t *rqh_p;
@@ -272,7 +277,7 @@
 } /* end of TSP_provider_rqh_manager_end */
 
 
-void TSP_provider_rqh_manager_waitend(void) {
+void TSP_provider_rqh_manager_waitend() {
 
   STRACE_IO(("-->INT"));
 
Index: src/core/ctrl/tsp_session.h
===================================================================
--- src/core/ctrl/tsp_session.h	(révision 4)
+++ src/core/ctrl/tsp_session.h	(révision 205)
@@ -55,7 +55,7 @@
 /**
  * Session initialisation.
  */
-void TSP_session_init(void);
+void TSP_session_init();
 
 /**
  * Close a session.
@@ -175,7 +175,7 @@
  * Get current total number of session.
  * @return Total number of session
  */
-int TSP_session_get_nb_session(void);
+int TSP_session_get_nb_session();
 
 /**
  * Change session state to target newState.
Index: src/core/ctrl/tsp_request_handler.h
===================================================================
--- src/core/ctrl/tsp_request_handler.h	(révision 4)
+++ src/core/ctrl/tsp_request_handler.h	(révision 205)
@@ -166,7 +166,7 @@
  * of TSP_provider_request_handler.
  * @return the maximum number of (registrable) request handler
  */
-int TSP_provider_rqh_manager_get_max_nb(void);
+int TSP_provider_rqh_manager_get_max_nb();
 
 /**
  * Get the current number
Index: src/core/ctrl/tsp_provider.c
===================================================================
--- src/core/ctrl/tsp_provider.c	(révision 4)
+++ src/core/ctrl/tsp_provider.c	(révision 205)
@@ -35,6 +35,13 @@
 -----------------------------------------------------------------------
  */
 
+/* FIXME car sinon pb avec pthread_self*/
+#ifdef WIN32
+    #define assert(exp)     ((void)0)
+#else
+    #include <assert.h>
+#endif
+#include <pthread.h>
 #include <tsp_sys_headers.h>
 #include <tsp_provider.h>
 #include <tsp_filter_symbol.h>
@@ -116,6 +123,10 @@
   char* p;
   int ret = TRUE;
 
+  if (NULL==argv) {
+      return ret;
+  }
+
   /* FIXME : FUITE */
   X_argv = (char**)calloc(*argc, sizeof(char*));
   X_glu_argv = (char**)calloc(*argc, sizeof(char*));
@@ -123,7 +134,9 @@
   TSP_CHECK_ALLOC(X_argv, FALSE);
   TSP_CHECK_ALLOC(X_glu_argv, FALSE);
   /* Get program name anyway */
+  
   X_argv[0] = (*argv)[0];
+  
   for( i = 1 ; i < *argc && ret ; i++)
     {
       /* Is the arg a TSP arg ? */
@@ -246,11 +259,11 @@
 }
 
 int 
-TSP_provider_is_initialized(void) {
+TSP_provider_is_initialized() {
   return  X_tsp_provider_init_ok;
 }
 
-int TSP_provider_get_server_base_number(void)
+int TSP_provider_get_server_base_number()
 {
   return  X_server_base_number;
 }
@@ -396,9 +409,10 @@
 					  int filter_kind, char* filter_string,
 					  TSP_answer_sample_t* ans_sample) {
 
-  STRACE_REQUEST(("FILTERED INFORMATIONS channel_id=<%d>",req_info->channel_id));
-  TSP_LOCK_MUTEX(&X_tsp_request_mutex,);  
   GLU_handle_t* myGLU = NULL;
+
+  STRACE_REQUEST(("FILTERED INFORMATIONS channel_id=<%d>",req_info->channel_id));
+  TSP_LOCK_MUTEX(&X_tsp_request_mutex,);
   
   /* fill-in minimal info in answer_sample */
   TSP_provider_update_answer_with_minimalinfo(req_info->version_id,req_info->channel_id,
@@ -437,9 +451,11 @@
 TSP_provider_request_sample(TSP_request_sample_t* req_sample, 
 			    TSP_answer_sample_t* ans_sample) {
 
+  GLU_handle_t* myGLU;
+  
   STRACE_REQUEST(("SAMPLE channel_id=<%d>",req_sample->channel_id));
   TSP_LOCK_MUTEX(&X_tsp_request_mutex,);	
-  GLU_handle_t* myGLU;
+  
   /* Always re-init answer_sample */
   TSP_AS_finalize(ans_sample);
   TSP_provider_update_answer_with_minimalinfo(req_sample->version_id,
Index: src/core/ctrl/tsp_default_glu.c
===================================================================
--- src/core/ctrl/tsp_default_glu.c	(révision 4)
+++ src/core/ctrl/tsp_default_glu.c	(révision 205)
@@ -37,7 +37,11 @@
 -----------------------------------------------------------------------
  */
 
-#include <assert.h>
+#ifdef WIN32
+    #define assert(exp)     ((void)0)
+#else
+    #include <assert.h>
+#endif
 #include <stdlib.h>
 #include <pthread.h>
 
@@ -54,7 +58,12 @@
   *glu = calloc(1,sizeof(GLU_handle_t));
   assert(*glu);
   /* set up field values */
+#if defined (WIN32)
+  /* structure pthread_t different under Windows */
+  (*glu)->tid.p           = 0;
+#else
   (*glu)->tid             = 0;
+#endif
   (*glu)->name            = strdup(name);
   (*glu)->type            = type;
   (*glu)->base_frequency  = base_frequency;
@@ -152,7 +161,12 @@
 
 int32_t
 GLU_start_default(GLU_handle_t* this) {
+#if defined (WIN32)
+  /* structure pthread_t different under Windows */
+  if (0==this->tid.p) {
+#else
   if (0==this->tid) {
+#endif
     return pthread_create(&(this->tid), NULL, this->run, this); 
   } else {
     return 0;
Index: src/core/ctrl/tsp_stream_sender.c
===================================================================
--- src/core/ctrl/tsp_stream_sender.c	(révision 4)
+++ src/core/ctrl/tsp_stream_sender.c	(révision 205)
@@ -35,14 +35,23 @@
 -----------------------------------------------------------------------
  */
 
-#include <unistd.h>  
-#include <netdb.h>
-#include <netinet/in.h>
-#include <netinet/tcp.h>
-#include <sys/socket.h>
 #include <signal.h>
+#include <pthread.h>
+#ifdef WIN32
+    #include <Windows.h>
+    #include <WinSock2.h>
+    #include <ws2tcpip.h>
+    #define assert(exp)     ((void)0)
+#else
+    #include <netdb.h>
+    #include <unistd.h>  
+    #include <netinet/in.h>
+    #include <netinet/tcp.h>
+    #include <sys/socket.h>
+    #include <assert.h>
+#endif
 
-#ifndef VXWORKS
+#if !defined (VXWORKS) && !defined(WIN32)
 #include <strings.h> /* for bzero */
 #endif
 #include <string.h>  /* for bzero too :=} */
@@ -119,11 +128,13 @@
 typedef struct TSP_socket_t TSP_socket_t;
 
 /* Signal functions */
-
+#if defined (WIN32)
+    /* no SIGPIPE signal uner Windows (waitforsingle obect insteed) */
+#else
 typedef void Sigfunc(int);
 
-Sigfunc* signal(int signo, Sigfunc* func)
-{
+Sigfunc* MySignal(int signo, Sigfunc* func)
+{    
   struct sigaction act, oact;
   
   act.sa_handler = func;
@@ -145,7 +156,7 @@
     return(SIG_ERR);
   return (oact.sa_handler);
 } 
-
+#endif
 
 void* TSP_streamer_sender_thread_sender(void* arg)
 {
@@ -201,21 +212,21 @@
 
   int status;
 
-  STRACE_IO(("-->IN"));
-
   RINGBUF_PTR_INIT(TSP_stream_sender_ringbuf_t,
 		   sock->out_ringbuf,
 		   TSP_stream_sender_item_t, 
 		   sock->buffer_size,
 		   RINGBUF_SZ(sock->fifo_size) );
-
+  
+  /* Memory Exhausted */
+  if (NULL==sock->out_ringbuf) {    
+    return FALSE;
+  }
   assert(sock->out_ringbuf);
 
   status = pthread_create(&sock->thread_id, NULL, TSP_streamer_sender_thread_sender,  sock);
   TSP_CHECK_THREAD(status, FALSE);
  
-  STRACE_IO(("-->OUT"));
-
   return TRUE;
   
 }
@@ -246,7 +257,12 @@
     
   /* Accept connection on socket */
   STRACE_DEBUG(("Thread acceptor started waiting for client to connect %d", sock->hClient));
+#if defined (WIN32)  
+  sock->hClient = accept(sock->socketId, NULL, NULL);
+#else
+  /* FIXME */
   sock->hClient = accept(sock->socketId, NULL, &Len);
+#endif
 
   if(sock->hClient > 0) {
     /* OK, the client is connected */
@@ -286,12 +302,15 @@
     uint8_t     parts[4];
   } myu;
 
+#if defined (WIN32)
+  /* no SIGPIPE signal under Windows (waitforsingleobject insteed) */
+#else
   /* First disable SIGPIPE signal to avoir being crashed by a disconnected client*/
-  if( SIG_ERR == signal(SIGPIPE, SIG_IGN)) {
+  if( SIG_ERR == MySignal(SIGPIPE, SIG_IGN)) {
     STRACE_ERROR(("Unable to disable SIGPIPE signal"));
     return 0;
   }
-  
+#endif
   if( -1 == gethostname(host, TSP_MAXHOSTNAMELEN))
     {
       STRACE_ERROR(("gethostname error"));
@@ -506,15 +525,27 @@
   Total = 0;
   if (identSocket > 0) {      
     while (bufferLen > 0) {
+/* sous windows _errno est la variable globale en lecture seule */
+#ifndef WIN32
       errno = 0;
+#endif
       /* FIXME is it really an error to get 0 as nwrite? */
-      if( (nwrite = write(identSocket,  &buffer[Total], bufferLen)) <= 0 ) {
+#ifdef WIN32
+	if( (nwrite = send(identSocket, &buffer[Total], bufferLen,0)) <= 0 ) {
+    if( _errno == EINTR ) {
+#else
+	  if( (nwrite = write(identSocket,  &buffer[Total], bufferLen)) <= 0 ) {
 	if( errno == EINTR ) {
+#endif
 	  /* The write might have been interrupted by a signal */
 	  nwrite = 0;
 	}
 	else {		  
-	  STRACE_DEBUG(("send failed with errno = %d : <%s>",errno,strerror(errno)));
+#ifdef WIN32
+     STRACE_DEBUG(("send failed with errno = %d : <%s>",WSAGetLastError(),strerror(errno)));   
+#else
+	  STRACE_ERROR(("send failed with errno = %d : <%s>",errno,strerror(errno)));
+#endif
 	  sock->connection_ok = FALSE;
 	  return FALSE;
 	}
